	; ARQUITECTURA DE COMPUTADORES II, 2014
	; TP 02: Arquitecturas Segmentadas
	;
	; Calcula los primeros 10 nmeros de la secuencia Fibonacci.
	;

	; Comienzo del segmento de datos
	; ---

	.data

	; Inicializo los dos primeros valores de la secuencia Fibonacci.
fibo:   .word32 1, 1

	; Comienzo del segmento de programa
	; ---

	.text
	
	; Inicializo el contador de ciclos para
	; que genere los siguientes 10 nmeros de
	; la secuencia.
	daddi R5,R0,10

	; Cargo la posicin del comienzo de la tabla en R4
	daddi R4,R0,fibo


loop:	; Cargo los dos nmeros anteriores de la secuencia en sendos registros
	lw R2,0(R4)
	lw R3,4(R4)

	; Los sumo para generar el nuevo nmero
	dadd  R3,R2,R3
	
	; Almaceno el resultado
	sw R3,8(R4)

	; Incremento el ndice de la tabla
	daddi R4,R4,4 

	; Decremento el contador de vueltas
	daddi R5,R5,-1

	; Salto de fin de bucle
	bnez R5,loop      


	halt


